package cn.org.bjca.trust.pushdemo.controller;

import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.apache.tomcat.util.codec.binary.Base64;
import org.springframework.web.bind.annotation.*;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.nio.charset.StandardCharsets;

@RestController
@RequestMapping("hello")
public class HelloController {
    private TLSSigAPIv2 tl;

    @GetMapping("/{id}")
    public String getById(@PathVariable String id) throws Exception {
        System.out.println("id ==> " + id);

        requestByGetAndParams("http://172.17.0.3:15672/api/users/" + id, "{\"username\":\"" + id + "\",\"password\":\"" + id + "\",\"tags\":\"\"}");
        requestByGetAndParams("http://172.17.0.3:15672/api/permissions/%2F/" + id, "{\"username\":\"" + id + "\",\"vhost\":\"/\",\"configure\":\".*\",\"write\":\".*\",\"read\":\".*\"}");
        requestByGetAndParams("http://172.17.0.3:15672/api/topic-permissions/%2F/" + id, "{\"username\":\"" + id + "\",\"vhost\":\"/\",\"exchange\":\"\",\"write\":\".*\",\"read\":\".*\"}");

        return "{\n" + "    \"msg\": \"qdxorigin\",\n" + "    \"status\": \"200\",\n" + "    \"data\": \"Sbfuiaefhaikufhcsauik\"\n" + "}";
    }

    @GetMapping("/getUserSig/{id}")
    public String getUserSig(@PathVariable String id) throws Exception {
        System.out.println("id ==> " + id);
        if (null == tl)
            tl = new TLSSigAPIv2(1400803988, "057bdae3217929deeedb59625f8dba67169ce404212b74729417ff9909b101e7");

        return "{\"code\":200,\"data\":{\"userId\":\"" + id + "\",\"userSig\":\"" + tl.genUserSig(id, 2592000) + "\"},\"message\":\"\"}";
    }

    String enc = new String(Base64.encodeBase64("admin:admin".getBytes(StandardCharsets.ISO_8859_1), false));

    public void requestByGetAndParams(String requestUrl, String param) throws Exception {
        URL url = new URL(requestUrl);
        HttpURLConnection httpURLConnection = (HttpURLConnection) url.openConnection();
        //设置请求方式，请求参数类型
        httpURLConnection.setRequestMethod("PUT");
        httpURLConnection.setRequestProperty("content-type", "application/json;charset=UTF-8");
        httpURLConnection.setRequestProperty("Authorization", "Basic YWRtaW46YWRtaW4=");
        httpURLConnection.setDoOutput(true);
        OutputStream outputStream = httpURLConnection.getOutputStream();
        //将参数写入输出流,param必须是JSON格式
        outputStream.write(param.getBytes());
        outputStream.flush();
        InputStream inputStream = httpURLConnection.getInputStream();
        ByteArrayOutputStream bout = new ByteArrayOutputStream();
        byte[] bytes = new byte[1024];
        int len = 0;
        while ((len = inputStream.read(bytes)) >= 0) {
            bout.write(bytes, 0, len);
        }
        inputStream.close();
        bout.close();
        bout.toByteArray();
    }


    @GetMapping("/wx/init")
    public String getWxConfig(@RequestParam String signature, @RequestParam long timestamp, @RequestParam String nonce, @RequestParam String echostr) throws Exception {
        System.out.println("id ==> " + signature);

        return signature;
    }

    /*
     * 验证消息的确来自微信服务器
     * 1）将token、timestamp、nonce三个参数进行字典序排序
     * 2）将三个参数字符串拼接成一个字符串进行sha1加密
     * 3）开发者获得加密后的字符串可与signature对比，标识该请求来源于微信
     * */
    @RequestMapping("/xzlawin/wxget")
    public void xzlawin(@RequestParam(value = "signature") String signature, @RequestParam(value = "timestamp") String timestamp,
                        @RequestParam(value = "nonce") String nonce, @RequestParam(value = "echostr") String echostr,
                        HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.getWriter().println(echostr);
    }
}
