package cn.org.bjca.trust.pushdemo.message;

public abstract class Message {
    private String messageId;
    private String from;
    private String to;
    private String tenantNo;
    private MsgType type = MsgType.UNKNOWN;
    private long timestamp;

    private boolean parseError = false;


    public String getTenantNo() {
        return tenantNo;
    }

    public void setTenantNo(String tenantNo) {
        this.tenantNo = tenantNo;
    }

    public String getMessageId() {
        return messageId;
    }

    public void setMessageId(String messageId) {
        this.messageId = messageId;
    }

    public String getFrom() {
        return from;
    }

    public void setFrom(String from) {
        this.from = from;
    }

    public String getTo() {
        return to;
    }

    public void setTo(String to) {
        this.to = to;
    }

    public MsgType getType() {
        return this.type;
    }

    public void setType(MsgType type) {
        this.type = type;
    }

    public boolean isParseError() {
        return parseError;
    }

    public void setParseError(boolean parseError) {
        this.parseError = parseError;
    }

    public long getTimestamp() {
        return timestamp;
    }

    public void setTimestamp(long timestamp) {
        this.timestamp = timestamp;
    }

//	public void parse(MsgType type, Object json) throws JSONException {
//		if (json instanceof JSONObject) {
//			JSONObject jsonObj = (JSONObject) json;
//			this.setMessageId(jsonObj.getString("messageId"));
//			this.setFrom(jsonObj.getString("from"));
//			this.setTo(jsonObj.getString("to"));
//			// this.setVersion(jsonObj.getString("version"));
//			this.setTimestamp(jsonObj.getLong("timestamp"));
//		}
//
//	};

    public void parse(MsgType type, SendMessage sendMessage) {
        this.setType(type);
        this.setMessageId(sendMessage.getMessageId());
        this.setFrom(sendMessage.getFromClientId());
        this.setTo(sendMessage.getToClientId());
        this.setTimestamp(sendMessage.getTimestamp());
        this.setTenantNo(sendMessage.getTenantNo());
    }


    public abstract String createContentJsonStr();

    protected String addContentHeader(String jsonStr) {
		/*
		StringBuffer buffer = new StringBuffer();
		buffer.append(this.getType().value());
		buffer.append(jsonStr);
		return buffer.toString();
		*/
        return jsonStr;
    }

}
