package cn.org.bjca.trust.pushdemo.message;

public enum MsgType {

    UNKNOWN(-1)     /* 未知 */,
    Text(1)         /* 文本   对应：Text(1) */,
    Voice(2)        /* 语音   对应：Voice(2) */,
    Image(3)        /* 图片   对应：Picture(3) */,
    Location(4)     /* 位置   对应：Location(4) */,
    Video(5)        /* 视频   对应：Video(5) */,
    VCard(6)        /* 名片   对应：Vcard(6) */,
    News(7)         /* 多图文 对应：MultiHtml(8) */,
    File(8)         /* 文件         对应：File(9) */,
    Link(9)         /* 链接 */,
    Music(10)       /* 音乐 */,
    At(11)          /* @我 */,
    PublicCard(12)  /* 公众号名片消息 */,
    Business(14),   /* 业务消息 */
    App(15),   /* 应用消息 */
    Other(10010),   /* 自定义消息 */
    //通知类消息
    //系统级
    OtherLogined(101)       /* 未知 */,
    ChangPassword(102)       /* web端修改密码 */,
    Cancel(110),            /* 撤销消息 */
    FriendRequest(121),     /* A加B，B收到的。好友申请通知消息 */
    FriendResponse(122),    /* A加B，B通过验证或回复消息，给A发的好友添加成功通知消息 */
    ContactAdded(123),      //A加B，不用验证，给B的通知
    ContactDeleted(124),    /* A删除B，给B的通知。好友删除通知消息 */
    UserAvatarChanged(125), /* 好友头像变更通知消息 */
    UserNicknameChanged(126),   /* 好友昵称变更通知消息 */
    GroupMemberAdded(141),      /* 群成员加入群消息     对应：GroupMemberAdded(20)*/
    GroupMemberDeleted(142),    /* 群成员退出群消息     对应：GroupDeleteMember(21)*/
    GroupMemberExited(143),     /* 用户主动退群： 群成员退出群消息 */
    GroupNameChanged(144),      /* 群名称变更消息 */
    GroupLogoChanged(145),      /* 群LOGO变更消息 */
    GroupMemberNicknameChanged(146),    /* 群成员昵称变更消息 */
    ReadMessage(147),    /* 已读消息 */
    GroupSavedAsContact(148),    /* 群保存通讯录 */
    OrganizationChanged(161),       /* 组织变更消息 */
    OrganizationMemberChanged(162), /* 组织成员变更消息 */
    UserJoinTenant(170),/* 用户加入租户 */
    UserLeaveTenant(171),/* 用户退出租户 */
    TodoTask(181),                   /* 待办消息 */
    PublicListChanged(200),        /* 公众号列表变更消息 */
    PublicWebsiteListChanged(201),        /* 应用列表变更消息 */
    ThirdAppClassChanged(202),        /* 应用分类变更消息 */
    ThirdAppLogin(203),        /* 第三方应用登录通知 */
    UserDisabled(210),               /* 用户禁用消息 */
    addComment(211),    /* 添加评论 */
    deleteComment(242),    /* 删除评论 */

    /**
     * pc 登陆 start
     */
    LoginRequestMessage(230),/*登录请求*/
    LoginWaittingMessage(231),/*等待登录*/
    LoginWaittingCancelMessage(232),/*取消等待*/
    LoginAuthorizationMessage(233),/*授权登录*/
    LoginStatusMessage(234),/*登录状态*/
    LoginQuitMessage(235),/*退出登录*/
    /**
     * pc 登陆 end
     */
    /**
     * 音频/视频消息 start
     */
    AVMeetingInvite(250),/*邀请通知*/
    AVMeetingRefuse(251),/*拒绝通知*/
    AVMeetingCancel(252),/*取消通知*/
    AVMeetingTimeout(253),/*超时通知*/
    AVMeetingBusy(254),/*占线通知*/
    AVMeetingSwitch(255),/*切换音频通知*/
    AVMeetingConnected(256),/* 聊天已连接通知*/
    MulAVMeetingInvite(260), /*群视频邀请*/
    MulAVMeetingRefuse(261), /*群成员拒绝通知*/
    MulAVMeetingCancel(262),/*取消通知*/
    MulAVMeetingTimeOut(263),/*超时通知 */
    /**
     * 音频/视频消息 end
     */
    Notify(999);


    private int value = -1;

    MsgType(final int value) {
        this.value = value;
    }

    public int value() {
        return this.value;
    }

    public static MsgType getValue(final int value) {
        for (final MsgType type : MsgType.values()) {
            if (type.value == value) {
                return type;
            }
        }
        return UNKNOWN;
    }

}
